<template>
  <div class="page-roster">
    <div class="c-row items-start">
      <div class="c-col">
        <poster-calendar
          v-model:selected-date="selectedDate"
          v-model:roster-month="rosterMonth"
          :class-schedule="resultSchedule"
        >
          <div class="row w-full gap-10px">
            <q-space />
            <q-btn @click="startPoster">
              開始排班
            </q-btn>
            <q-btn @click="previewClassSchedule">
              預覽目前班表
            </q-btn>
          </div>
        </poster-calendar>
        <q-card class="mt-30px">
          <q-card-section>
            <div class="text-item">
              <div class="text-12px">
                當月天數
              </div>
              <q-space />
              <div class="text-12px">
                {{ monthDays }}
              </div>
            </div>
            <div class="text-item">
              <div class="text-12px">
                無工作天數
              </div>
              <q-space />
              <div class="text-12px">
                {{ unscheduledDays }}
              </div>
            </div>
            <div class="text-item">
              <div class="text-12px">
                工作天數
              </div>
              <q-space />
              <div class="text-12px">
                {{ scheduledDays }}
              </div>
            </div>
          </q-card-section>
        </q-card>
      </div>
      <table-day-itinerary
        class="ml-30px"
        :target-date="selectedDate"
        :class-schedule="resultSchedule"
      /><!-- 儲存已排定班表-->
      <poster-storager
        class="ml-30px"
        :class-schedule="resultSchedule"
      />
    </div>
    <q-dialog
      v-model="previewerVisible"
      full-width
      full-height
    >
      <q-card class="h-full">
        <q-card-section class="c-row items-center">
          <q-space />
          <q-btn
            v-close-popup
            icon="close"
            flat
            round
            dense
          />
        </q-card-section>
        <q-card-section>
          <previewer-class-schedule :class-schedule="resultSchedule" />
        </q-card-section>
      </q-card>
    </q-dialog>
  </div>
</template>

<script lang='ts' setup>
import {
  computed,
  nextTick,
  reactive,
  ref,
  watch,
  watchEffect,
} from 'vue';
import dayjs from 'dayjs';
import { ClassSchedule } from '../types/main.type';

import PosterCalendar from '../views/page-roster/poster-calendar.vue';
import TableDayItinerary from './page-roster/table-day-itinerary.vue';
import PreviewerClassSchedule from '../components/previewer-class-schedule.vue';
import PosterStorager from './page-roster/poster-storager.vue';

import { useStatisticalData } from '../composables/use-statistical-data';
import { usePoster } from '../composables/use-poster';
import { useQuasar } from 'quasar';
import { useMainStore } from '../store/main.store';
import { useRuleStore } from '../store/rule.store';

const $q = useQuasar();
const store = useMainStore();
const ruleStore = useRuleStore();

const selectedDate = ref('');
const rosterMonth = ref(dayjs().format('YYYY/MM'));

const dayItineraries = computed(() => store.dayItineraries);

const rules = computed(() => ruleStore.rules);
const staff = computed(() => store.staff);
const jobs = computed(() => store.jobs);
const jobTypes = computed(() => store.jobTypes);
const holidays = computed(() => store.holidays);

/** 當月日行程 */
const currentMonthItineraries = computed(() => {
  return dayItineraries.value.filter((item) => {
    return item.date.includes(rosterMonth.value);
  });
});

/** 統計資料 */
const { monthDays, scheduledDays, unscheduledDays } = useStatisticalData({
  rosterMonth,
  dayItineraries,
});

/** 班表 */
const classSchedule = reactive<ClassSchedule>({
  name: '',
  description: '',
  month: '',
  itineraries: [],
});
watchEffect(() => {
  classSchedule.month = rosterMonth.value;
  classSchedule.itineraries = currentMonthItineraries.value;
});

/** 排完班表 */
const resultSchedule = ref<ClassSchedule>();
const notCompleted = computed(() => {
  if (!resultSchedule.value) {
    return false;
  }

  return resultSchedule.value.itineraries.some((itinerary) => {
    return itinerary.vacancies.some((vacancy) => {
      return !vacancy.executor;
    });
  });
});
watch(rosterMonth, () => {
  resultSchedule.value = undefined;
});

const { calcClassSchedule } = usePoster({
  rules: rules.value,
  staff: staff.value,
  jobs: jobs.value,
  jobTypes: jobTypes.value,
  holidays: holidays.value,
});

async function startPoster() {
  // $q.loading.show({
  //   message: '努力排班中',
  // });
  resultSchedule.value = calcClassSchedule(classSchedule);
  // console.log(`[ startPoster ] result : `, resultSchedule.value);
  // $q.loading.hide();

  await nextTick();

  if (notCompleted.value) {
    $q.notify({
      type: 'warning',
      message:
        '某些工作無法排定工作人員，請「確認工作設定是否有誤」或「手動排入適合人選」',
    });
    return;
  }

  $q.notify({
    type: 'positive',
    message: '班表排定完成',
  });
}
// setTimeout(() => {
//   startPoster();
// }, 500);

const previewerVisible = ref(false);
function previewClassSchedule() {
  if (!resultSchedule.value) {
    $q.notify({
      type: 'negative',
      message: '尚未排定班表，無法預覽',
    });
    return;
  }

  previewerVisible.value = true;
}
</script>

<style scoped lang='sass'>

.page-roster
  width: 100%
  height: 100%
  display: flex
  flex-direction: column
  justify-content: center
  align-items: center
  .text-item
    display: flex
    &:not(:first-child)
      margin-top: 5px
</style>
